
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class V1::StatisticsController < ApplicationController
  # GET v1/statistics
  # GET v1/statistics.json
  def index
    statistics = { count: count_learning_objects, month_publications: month_publications, month_downloads: month_downloads }
    render json: statistics
  end

  private

  def count_learning_objects
    LearningObject.where('state = ?', LearningObject.states[:published]).count
  end

  def month_publications
    LearningObject.where('extract (month from published_at) = ? and extract (year from published_at) = ?', Time.current.month, Time.current.year).count
  end

  def month_downloads
    Download.where('extract (month from created_at) = ? and extract (year from created_at) = ?', Time.current.month, Time.current.year).count
  end
end
