
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

## Metadatable concern for models which have metadata
# This concern will include some methods to handle @metadata attr of application models
module Metadatable
  extend ActiveSupport::Concern

  included do
    serialize :metadata, ArraySerializer
  end

  def get_metadata_value_of(key)
    get_metadata_values_of(key).first
  end

  def get_metadata_values_of(key)
    return [] if metadata.blank?
    metadata[key].blank? ? [] : metadata[key]
  end
end
