
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: score_user_categories
#
#  id               :integer          not null, primary key
#  score_id         :integer
#  user_category_id :integer
#  value            :float
#  created_at       :datetime         not null
#  updated_at       :datetime         not null
#

class ScoreUserCategory < ApplicationRecord
  belongs_to :score
  belongs_to :user_category

  validates_presence_of :score, :user_category, :value
  validates_uniqueness_of :user_category, scope: :score

  after_commit :calculate_reference, on: :update

  private

  def calculate_reference
    user_category.calculate_reference
  end
end
