
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class SubmissionPolicy < ApplicationPolicy

  def index?
    record if user_can_curate?
  end

  def show?
    record if user_can_curate? || owns?
  end

  def create?
    record if user_can_create?
  end

  def answer?
    record if user_can_curate?
  end

  def destroy?
    record if record.submitted? && owns?
  end

  def owner
    record.submitter
  end

  def user_can_create?
    return user_exists? && user.is_submitter? && record.learning_object.draft? && record.learning_object.publisher == user
  end

end
