
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class CollectionItemSerializer < ActiveModel::Serializer
  cache key: 'collection_item', expires_in: 24.hours
  
  def collectionable
    if ( object.collectionable_type == "LearningObject" )
    	serializer = ::LearningObjectSerializer
    elsif ( object.public? || (current_user && ( object.owner?(current_user) || current_user.can_edit? )) )
    	serializer = ::CollectionMinSerializer
    end

    if ( !serializer.blank? )
    	serializer.new(object.collectionable, {scope: current_user, scope_name: :current_user}).serializable_hash
  	end
  end

  belongs_to :collectionable, polymorphic: true
  attributes :id, :position, :collectionable, :collectionable_type
end
