
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class InstitutionImporter

  attr_accessor :items

  def initialize
    @names = []
    @learning_objects = []
  end

  def import
    @items.each do |learning_object|
      publisher = learning_object.get_metadata_value_of 'dc.creator'
      if publisher.nil?
        institution = Institution.where(name: "Banco Internacional de Objetos Educacionais").first_or_create
      elsif !institution_exists?(publisher)
        institution = Institution.new(name: publisher)
        institution.save
        @names << publisher
      else
        institution = Institution.find_by_name(publisher)
      end


      learning_object.publisher = institution
      learning_object.save
    end
  end

  private

  def institution_exists?(publisher)
    exists = @names.include? publisher
    unless exists
      exists = Institution.exists?(name: publisher)
      @names << publisher if exists
    end
    exists
  end
end
