
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class CreateLearningObjects < ActiveRecord::Migration[4.2]
  def change
    create_table :learning_objects do |t|
      t.integer :id_dspace
      t.string :name
      t.string :author
      t.text :description
      t.datetime :published_at
      t.integer :score, default: 0
      t.integer :school_level
      t.jsonb :metadata
      t.text :bitstreams
      t.string :thumbnail
      t.text :keywords

      t.references :publisher, polymorphic: true, index: true
      t.references :language, index: true
      t.references :object_type, index: true

      t.timestamps null: false
    end
    add_index :learning_objects, :id_dspace, unique: true
    add_foreign_key :learning_objects, :languages
    add_foreign_key :learning_objects, :object_types
  end
end
