
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

def get_action(name)
  Action.where(name: name).first
end

def get_achievement(name)
  Achievement.where(name: name).first
end

def requirements
  main_requirements = {
    "Introduzido Nível I": [{ goal: 1, description: "Assistir ao vídeo de apresentação na plataforma", repeatable: false, action: get_action("Assistir Apresentação") }],
    
    "Introduzido Nível II": [
      { goal: 1, description: "Utilizar um recurso", repeatable: false, action: get_action("Visualizar um Recurso") },
      { goal: 1, description: "Criar uma coleção privada", repeatable: false, action: get_action("Criar Coleção") },
      { goal: 1, description: "Utilizar um material", repeatable: false, action: get_action("Visualizar um Material") },
      { goal: 1, description: "Marcar um item como favorito", repeatable: false, action: get_action("Favoritar") },
      { goal: 1, description: "Avaliar um item", repeatable: false, action: get_action("Avaliar") },
      { goal: 1, description: "Seguir um usuário", repeatable: false, action: get_action("Seguir Usuário") },
      { goal: 1, description: "Salvar um item", repeatable: false, action: get_action("Adicionar Recurso a Coleção") }
    ],

    "Personalizado": [
      { goal: 1, description: "Adicionar foto de perfil", repeatable: false, action: get_action("Adicionar Foto de Perfil") },
      { goal: 1, description: "Adicionar capa de perfil", repeatable: false, action: get_action("Adicionar Capa de Perfil") },
      { goal: 1, description: "Adicionar 'Sobre Mim'", repeatable: false, action: get_action("Adicionar Descrição do Usuário") },
    ],

    "Professor": [{ goal: 1, description: "Ser autenticado como professor", repeatable: false, action: get_action("Autenticação de Professor") }],
    
    "Frequente Nível I": [{ goal: 5, description: "Acessar a plataforma por 5 dias consecutivos", repeatable: false, action: get_action("Fazer Login") }],
    "Frequente Nível II": [{ goal: 15, description: "Acessar a plataforma por 15 dias consecutivos", repeatable: false, action: get_action("Fazer Login") }],
    "Frequente Nível III": [{ goal: 60, description: "Acessar a plataforma por 60 dias consecutivos", repeatable: false, action: get_action("Fazer Login") }],
    "Frequente Nível IV": [{ goal: 120, description: "Acessar a plataforma por 120 dias consecutivos", repeatable: false, action: get_action("Fazer Login") }],
    "Frequente Nível V": [{ goal: 365, description: "Acessar a plataforma por 365 dias consecutivos", repeatable: false, action: get_action("Fazer Login") }],

    "Nostálgico Nível I": [{ goal: 6, description: "Usuário há 6 meses", repeatable: false, action: get_action("Meses de Conta") }],
    "Nostálgico Nível II": [{ goal: 12, description: "Usuário há 1 ano", repeatable: false, action: get_action("Meses de Conta") }],
    "Nostálgico Nível III": [{ goal: 24, description: "Usuário há 2 anos", repeatable: false, action: get_action("Meses de Conta") }],
    "Nostálgico Nível IV": [{ goal: 36, description: "Usuário há 3 anos", repeatable: false, action: get_action("Meses de Conta") }],
    "Nostálgico Nível V": [{ goal: 48, description: "Usuário há 4 anos", repeatable: false, action: get_action("Meses de Conta") }],

    "Contribuidor Nível I": [{ goal: 1, description: "Publicar 1 recurso", repeatable: false, action: get_action("Publicar") }],
    "Contribuidor Nível II": [{ goal: 10, description: "Publicar 10 recursos", repeatable: false, action: get_action("Publicar") }],
    "Contribuidor Nível III": [{ goal: 50, description: "Publicar 50 recursos", repeatable: false, action: get_action("Publicar") }],
    "Contribuidor Nível IV": [{ goal: 200, description: "Publicar 200 recursos", repeatable: false, action: get_action("Publicar") }],
    "Contribuidor Nível V": [{ goal: 1000, description: "Publicar 1000 recursos", repeatable: false, action: get_action("Publicar") }],

    "Dias Produtivos Nível I": [{ goal: 2, description: "Publicar 2 recursos em um dia", repeatable: false, action: get_action("Publicar") }],
    "Dias Produtivos Nível II": [{ goal: 5, description: "Publicar 5 recursos em um dia", repeatable: false, action: get_action("Publicar") }],
    "Dias Produtivos Nível III": [{ goal: 10, description: "Publicar 10 recursos em um dia", repeatable: false, action: get_action("Publicar") }],
    "Dias Produtivos Nível IV": [{ goal: 20, description: "Publicar 20 recursos em um dia", repeatable: false, action: get_action("Publicar") }],
    "Dias Produtivos Nível V": [{ goal: 50, description: "Publicar 50 recursos em um dia", repeatable: false, action: get_action("Publicar") }],

    "Utilizador Assíduo Nível I": [{ goal: 10, description: "Utilizar 10 recursos", repeatable: false, action: get_action("Visualizar um Recurso") }],
    "Utilizador Assíduo Nível II": [{ goal: 50, description: "Utilizar 50 recursos", repeatable: false, action: get_action("Visualizar um Recurso") }],
    "Utilizador Assíduo Nível III": [{ goal: 200, description: "Utilizar 200 recursos", repeatable: false, action: get_action("Visualizar um Recurso") }],
    "Utilizador Assíduo Nível IV": [{ goal: 1000, description: "Utilizar 1000 recursos", repeatable: false, action: get_action("Visualizar um Recurso") }],
    "Utilizador Assíduo Nível V": [{ goal: 5000, description: "Utilizar 5000 recursos", repeatable: false, action: get_action("Visualizar um Recurso") }],

    "Colecionador Nível I": [{ goal: 5, description: "Utilizar 5 coleções", repeatable: false, action: get_action("Visualizar uma Coleção") }],
    "Colecionador Nível II": [{ goal: 30, description: "Utilizar 30 coleções", repeatable: false, action: get_action("Visualizar uma Coleção") }],
    "Colecionador Nível III": [{ goal: 100, description: "Utilizar 100 coleções", repeatable: false, action: get_action("Visualizar uma Coleção") }],
    "Colecionador Nível IV": [{ goal: 1000, description: "Utilizar 1000 coleções", repeatable: false, action: get_action("Visualizar uma Coleção") }],

    "Curador Nível I": [{ goal: 20, description: "Avaliar 20 recursos com estrelas", repeatable: false, action: get_action("Avaliar") },
      { goal: 20, description: "Avaliar 20 recursos com comentários", repeatable: false, action: get_action("Comentar") }],
    "Curador Nível II": [{ goal: 200, description: "Avaliar 200 recursos com estrelas", repeatable: false, action: get_action("Avaliar") },
      { goal: 200, description: "Avaliar 200 recursos com comentários", repeatable: false, action: get_action("Comentar") }],
    "Curador Nível III": [{ goal: 500, description: "Avaliar 500 recursos com estrelas", repeatable: false, action: get_action("Avaliar") },
      { goal: 500, description: "Avaliar 500 recursos com comentários", repeatable: false, action: get_action("Comentar") }],
    "Curador Nível IV": [{ goal: 1000, description: "Avaliar 1000 recursos com estrelas", repeatable: false, action: get_action("Avaliar") },
      { goal: 1000, description: "Avaliar 1000 recursos com comentários", repeatable: false, action: get_action("Comentar") }],
    # "Curador Nível V": [{ goal: 5000, description: "Avaliar 5000 recursos com estrelas", repeatable: false, action: get_action("Avaliar") },
    #   { goal: 5000, description: "Avaliar 5000 recursos com comentários", repeatable: false, action: get_action("Comentar") }],

    "Curador Assíduo Nível I": [{ goal: 10, description: "Avaliar 10 recursos com estrelas em um dia", repeatable: false, action: get_action("Avaliar") },
      { goal: 10, description: "Avaliar 10 recursos com comentários em um dia", repeatable: false, action: get_action("Comentar") }],
    "Curador Assíduo Nível II": [{ goal: 20, description: "Avaliar 20 recursos com estrelas em um dia", repeatable: false, action: get_action("Avaliar") },
      { goal: 20, description: "Avaliar 20 recursos com comentários em um dia", repeatable: false, action: get_action("Comentar") }],
    "Curador Assíduo Nível III": [{ goal: 50, description: "Avaliar 50 recursos com estrelas em um dia", repeatable: false, action: get_action("Avaliar") },
      { goal: 50, description: "Avaliar 50 recursos com comentários em um dia", repeatable: false, action: get_action("Comentar") }],

    "Conectado Nível I": [{ goal: 10, description: "Seguir 10 usuários", repeatable: false, action: get_action("Seguir Usuário") }],
    "Conectado Nível II": [{ goal: 50, description: "Seguir 50 usuários", repeatable: false, action: get_action("Seguir Usuário") }],
    "Conectado Nível III": [{ goal: 200, description: "Seguir 200 usuários", repeatable: false, action: get_action("Seguir Usuário") }],

    "Conhecido Nível I": [{ goal: 10, description: "Ser seguido por 10 usuários", repeatable: false, action: get_action("Ser Seguido") }],
    "Conhecido Nível II": [{ goal: 50, description: "Ser seguido por 50 usuários", repeatable: false, action: get_action("Ser Seguido") }],
    "Conhecido Nível III": [{ goal: 200, description: "Ser seguido por 200 usuários", repeatable: false, action: get_action("Ser Seguido") }],

    "Divulgador Nível I": [{ goal: 1, description: "Compartilhar 1 recurso", repeatable: false, action: get_action("Compartilhar") }],
    "Divulgador Nível II": [{ goal: 20, description: "Compartilhar 20 recursos", repeatable: false, action: get_action("Compartilhar") }],
    "Divulgador Nível III": [{ goal: 100, description: "Compartilhar 100 recursos", repeatable: false, action: get_action("Compartilhar") }]
  }

  subject_requirements = {}
  Subject.all.each do |subject|
    subject_requirements["Proficiência em #{subject.name} Nível I"] = [{ goal: 20, description: "Utilizar 20 recursos de #{subject.name}", repeatable: false, action: get_action("Visualizar um Recurso de #{subject.name}") }]
    subject_requirements["Proficiência em #{subject.name} Nível II"] = [{ goal: 50, description: "Utilizar 50 recursos de #{subject.name}", repeatable: false, action: get_action("Visualizar um Recurso de #{subject.name}") }]
    subject_requirements["Proficiência em #{subject.name} Nível III"] = [{ goal: 150, description: "Utilizar 150 recursos de #{subject.name}", repeatable: false, action: get_action("Visualizar um Recurso de #{subject.name}") }]
    subject_requirements["Proficiência em #{subject.name} Nível IV"] = [{ goal: 500, description: "Utilizar 500 recursos de #{subject.name}", repeatable: false, action: get_action("Visualizar um Recurso de #{subject.name}") }]
    subject_requirements["Proficiência em #{subject.name} Nível V"] = [{ goal: 1000, description: "Utilizar 1000 recursos de #{subject.name}", repeatable: false, action: get_action("Visualizar um Recurso de #{subject.name}") }]
  end
  main_requirements.merge(subject_requirements)
end

requirements.each do |achievement, requirement|
  requirement.each do |req|
    get_achievement(achievement).requirements.where(req).first_or_create
  end
end
