
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'rainbow'

namespace :thumbnail do
  desc 'Create thumbnail to every learning object without one'
  task :create_missing, [:log] => [:environment] do |t, args|
    include Log::Logging

    args.with_defaults(:log => STDOUT)

    Log::Logging.logger = Log::DatabaseLogger.new(args.log)
    logger.level = Log::DatabaseLogger::CREATE

    logger.info ' --> Creating thumbnails'

    LearningObject.missing_thumbnail.find_each do |object|
      object.attachments.where(bundle_name: 'ORIGINAL').find_each { |a| ThumbnailGenerateWorker.perform_async(a.id) } unless object.attachments.blank?
    end

    logger.close
  end
end
